// whoami.cpp:
//
// find out who you are
//
// jim frost 04.06.95

#include <stdio.h>
#include "security.hpp"

void whoami()
{
  // find out who we are
  char account_buffer[1024];
  DWORD account_size = sizeof(account_buffer);
  char* account = account_buffer;

  while (!GetUserName(account, &account_size)) {
    if (account != account_buffer)
      delete[] account;

    switch (GetLastError()) {
    case ERROR_NOT_ENOUGH_MEMORY:
      account = new char[account_size];
      break;
    default:
      fprintf(stderr, "Could not find your account name!\n");
	  return;
    }
  }

  SecurityIdentifier* sid = CreateSecurityIdentifier(account);

  if (sid == NULL)
    printf("I can't figure out who you are!\n");
  else
    printf("You are \\\\%s\\%s\n", sid->GetDomain(), sid->GetAccount());

  if (account != account_buffer)
    delete[] account;

}
